> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/vnic/attachnetworkinterface.md).

# AttachNetworkInterface

## 1. API Description

This API (AttachNetworkInterface) is used to attach a network interface to an instance.

{% hint style="info" %}
**Notes**

* The instance and the network interface to be attached must be in the same region.
* The number of network interfaces that can be attached to an instance depends on the instance type.
* Make sure that the instance is running when attaching, that is, the instance status is `RUNNING`.
* The network interface status must be `AVAILABLE`, that is, it is not attached to any instance.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                                             |
| -------------- | -------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| nicId          | Yes      | String | <p>ID of the network interface to be operated on.</p><p>It can be obtained by calling <a href="/api-reference/zec/vnic/describenetworkinterfaces.md">DescribeNetworkInterfaces</a>.</p> |
| instanceId     | Yes      | String | <p>ID of the instance to be bound.</p><p>It can be obtained by calling <a href="/api-reference/zec/instance/describeinstances.md">DescribeInstances</a>.</p>                            |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Attach the vNIC to the instance.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AttachNetworkInterface
<Common Request Params>

Request:
{
  "nicId": "XXX",
  "instanceId": "xxx"
}

Response:
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                        | Description                                                                          |
| ---------------- | ------------------------------------------------- | ------------------------------------------------------------------------------------ |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                     | Instance not found.                                                                  |
| 400              | INVALID\_NIC\_ATTACHED                            | The vNIC has attached to an instance already.                                        |
| 409              | INVALID\_NIC\_INSTANCE\_REGION\_MISMATCH          | Instance and vNIC are not in the same zone.                                          |
| 404              | INVALID\_NIC\_NOT\_FOUND                          | vNIC does not exist.                                                                 |
| 400              | INVALID\_NIC\_STATUS                              | Current vNIC state does not allow this operation.                                    |
| 400              | OPERATION\_DENIED\_INSTANCE\_STATUS\_NOT\_SUPPORT | Current instance state does not allow this operation.                                |
| 400              | OPERATION\_DENIED\_INSTANCE\_QGA\_NOT\_AVAILABLE  | The QGA of the instance is unavailable, so the network interface cannot be attached. |
